# Generated by `rjournal_article()` using `knitr::purl()`: do not edit by hand
# Please edit sandbox.Rmd to modify this file

## ----include=FALSE------------------------------------------------------------
knitr::opts_chunk$set(out.width = "\\textwidth")



## ---- warning=FALSE, message=FALSE, include = FALSE,eval=FALSE, comment='\n', echo=FALSE, results='asis'----

 cat(readLines('skeleton.Rmd'),sep='\n') #or results='hold'/'asis/tex? 'asis' doesn't show YAML header


## ----fig-skeleton, echo=FALSE, fig.cap='A comparison of minimal examples of a typical .Rmd document and a .Rmd document for an interactive sandbox app.', fig.subcap=c('A typical .Rmd file', 'A sandbox app .Rmd file'), fig.ncol = 2, fig.align='center', out.width='.49\\linewidth'----
knitr::include_graphics('skeleton-md.png')
knitr::include_graphics('skeleton.png')


## ----fig2, echo=FALSE, fig.cap='A screenshot of the GB rainfall interactive notebook site. The main feature is the code box. When the site loads, the code that generates the published version of the figure is in the box and the published version of the figure is below it. Users can make edits and re-run the code in the code box and the figure will update accordingly. Users can use the "Start Over" button to see the published version of the code at any point without refreshing the entire site.'----
knitr::include_graphics('GB_notebook_screenshot.png')


## ----fig1, echo=FALSE, fig.cap='The various levels of abstraction of various types of R documents. Our approach fills nicely the gap between R Markdown or Jupyter notebooks and Shiny apps.'----
knitr::include_graphics('learnr_abstraction.png')


## ----table1,  echo=FALSE, warning=FALSE, message=FALSE, results='hide', eval=FALSE----
#> require(pander)
#> require(dplyr)
#> panderOptions('digits', 3)
#> panderOptions('round', 3)
#> panderOptions('keep.trailing.zeros', TRUE)
#> panderOptions('keep.line.breaks', TRUE)
#> table1 = tibble( Stakeholders= c("Authors", "Other researchers (those wanting to try or compare the method)",
#>                                  "Other researchers (those curious about the results)",
#>                                  "Data Centres",
#>                                  "Funders",
#>                                  "Wider research community and general public)"),
#>                  Advantages = c("
#>                                      \\\n
#>                                      \\\n &bullet; Very little extra work required in additional to writing R markdown document.
#>                                       \\\n &bullet; No experience to generate web interfaces required.
#>                                       \\\n &bullet; Much greater impact in research output.\\\n ",
#>                                 '
#>                                      \\\n
#>                                      \\\n &bullet; A much more enriched experience to try methods and data and to test alternative hypothesis and scenarios.
#>                                      \\\n &bullet; No need to download data and scripts/notebooks and install packages to try a method.
#>                                      \\\n &bullet; More efficient to learn the new method.\\\n
#>                                     ','
#>                                      \\\n
#>                                      \\\n &bullet; Try running different scenarios quickly than the published ones without the hassle of full knowledge of the code, downloading the code and data, and setting up the software environment.
#>                                      \\\n &bullet; Quickly reset to the published version of code snippet. No need to worry about breaking the code.\\\n
#> 
#>                                     ','
#>                                      \\\n &bullet; A new avenue to demonstrate impact to funders if end users try methods or datasets hosted by them in sandboxes.\\\n
#>                                     ','
#>                                      \\\n &bullet; Better value of investment if even small parts of a research is readily reproducible.
#>                                      \\\n &bullet; Time saving to fund related work that builds on research documented this way.\\\n
#> 
#>                                     ','
#>                                      \\\n &bullet; 	Promotes trust and confidence in research through transparency.\\\n
#>                                     '))
#> 


## ----table1-descriptionsb, results = 'asis', echo = FALSE, message = FALSE, warning = FALSE, include=TRUE, eval=FALSE----
#> cap1 = function(is_latex){
#>   if(is_latex==TRUE) {
#>     "Advantages of the proposed approach to various stakeholders"} else{
#>     "Table 1: Advantages of the proposed approach to various stakeholders"
#>   }}
#> 
#> pandoc.table(table1, style = "multiline", justify = "left", caption = cap1(knitr::is_latex_output()) )


## ----table1-descriptions, results = 'asis', echo = FALSE, message = FALSE, warning = FALSE, include=FALSE, eval=FALSE----
#> 
#> pandoc.table(table1, style = "multiline", justify = "left", caption = 'abc' )


## ----tb1,  echo=FALSE, warning=FALSE, message=FALSE, results='hide'-----------
library(dplyr)
library(kableExtra)
table1 = tibble(Stakeholders= c("Authors", "Authors", "Authors", 
                                "Other researchers (those wanting to try or compare the method)", "Other researchers (those wanting to try or compare the method)", "Other researchers (those wanting to try or compare the method)",
                                 "Other researchers (those curious about the results)", "Other researchers (those curious about the results)", "Other researchers (those curious about the results)", 
                                 "Data Centres",
                                 "Funders", "Funders",
                                 "Wider research community and general public"),
                 Advantages = c("Very little extra work required in additional to writing R markdown document.",
                                "No experience to generate web interfaces required.", 
                                "Much greater impact in research output.",
                                "A much more enriched experience to try methods and data and to test alternative hypothesis and scenarios.",
                                "No need to download data and scripts/notebooks and install packages to try a method.", 
                                "More efficient to learn the new method.", 
                                "Try running different scenarios quickly than the published ones without the hassle of full knowledge of the code, downloading the code and data, and setting up the software environment.",
                                "Quickly reset to the published version of code snippet.", 
                                "No need to worry about breaking the code.", 
                                "A new avenue to demonstrate impact to funders if end users try methods or datasets hosted by them in sandboxes.", 
                                "Better value of investment if even small parts of a research is readily reproducible.",
                                "Time saving to fund related work that builds on research documented this way.",
                                "Promotes trust and confidence in research through transparency.")) 



## ----tb1-latex, eval = knitr::is_latex_output(), echo=FALSE-------------------
knitr::kable(table1[,2], format = "latex", caption = "Advantages of the proposed approach to various stakeholders") %>%
  pack_rows(index=c("Authors"=3, "Other researchers (those wanting to try or compare the method)"=3, "Other researchers (those curious about the results)"=3, "Data Centres"=1, "Funders"=2, "Wider research community and general public"=1))


## ----tb1-html, eval = knitr::is_html_output(), echo=FALSE---------------------
#> knitr::kable(table1[,2], format = "html", caption = "Advantages of the proposed approach to various stakeholders") %>%
#>   pack_rows(index=c("Authors"=3, "Other researchers (those wanting to try or compare the method)"=3, "Other researchers (those curious about the results)"=3, "Data Centres"=1, "Funders"=2, "Wider research community and general public"=1))


## ----table2,  echo=FALSE, warning=FALSE, message=FALSE, results='hide', eval=FALSE----
#> library(pander)
#> panderOptions('digits', 3)
#> panderOptions('round', 3)
#> panderOptions('keep.trailing.zeros', TRUE)
#> panderOptions('keep.line.breaks', TRUE)
#> table2 = tibble( Technology= c("R script","Static notebooks","Web apps (e.g. Shiny)","Binder/Google Colab"),
#>                  `Potential Issues` = c('
#>                                      \\\n
#>                                      \\\n &bullet; Limited narrative. Needs to run all the scripts.\\\n
#>                                     ','
#>                                      \\\n
#>                                      \\\n &bullet; Needs to download the code, data and package to try it out.\\\n
#>                                     ','
#>                                      \\\n
#>                                      \\\n &bullet; While web apps helpful to some stakeholders, it can be too high-level to some.
#>                                      \\\n &bullet; Lots of extra work to create web interface.
#>                                      \\\n &bullet; Does not expose the code to generate results.\\\n
#>                                     ','
#>                                      \\\n &bullet; Users change the entire notebook.
#>                                      \\\n &bullet; Users need to run all cells about the section they are interested in.\\\n
#>                                     '),
#>                  `How our approach can help?` = c('
#>                                       \\\n
#>                                      \\\n &bullet; Much richer narrative and interactive experience.\\\n
#>                                     ','
#>                                      \\\n
#>                                      \\\n &bullet; Can instantly try out the code in a controlled manner, using the published data/packages/software environment.\\\n
#>                                     ','
#>                                      \\\n
#>                                      \\\n &bullet; Users can interact with the code within the code snippet sandboxes themselves.
#>                                      \\\n &bullet; The published version of the code is shown to users.
#>                                      \\\n &bullet; Users can run the code snippets live.\\\n
#>                                     ','
#>                                      \\\n &bullet; A much more enriched and guided experience.
#>                                      \\\n &bullet; Users can choose to only run the sandboxes they are interested in.\\\n
#>                                     '))
#> 


## ----table2-descriptions, results = 'asis', echo = FALSE, message = FALSE, warning = FALSE, include=TRUE, eval=FALSE----
#> cap2 = function(is_latex){
#>   if(is_latex==TRUE) {
#>     "Advantages of the proposed approach to existing approaches"} else{
#>     "Table 2: Advantages of the proposed approach to existing approaches"
#>   }}
#> pandoc.table(table2, style = "grid", justify = "left", split.tables=Inf, split.cells = c(4, 10, 10), caption = cap2(knitr::is_latex_output()))


## ---- include=FALSE ,warning=FALSE, message=FALSE, comment='\n'---------------
#cat(readLines('/data/rain_pattern/results_tut.Rmd'),sep='\n')

